#include <unistd.h>
#include <stdio.h>
#include <dirent.h>
#include <string.h>
#include <sys/stat.h>
#include <stdlib.h>

#define eDIROpen	-1
#define eNoErr		0

int OpenDir(char *path, int *item_count);

void printdir(char *dir, int depth)
{
	DIR *dp;
	struct dirent *entry;
	struct stat statbuf;
	
	if ((dp=opendir(dir)) == NULL) {
		fprintf(stderr,"can't open directory: %s\n",dir);
		return;
	}
	
	// chdir(dir);
	while((entry = readdir(dp)) != NULL) {
		lstat(entry->d_name, &statbuf);
		if (statbuf.st_mode == S_IFREG) {
			printf("F %s*s%s\n",depth,"",entry->d_name);
		}
		else {
			if (strcmp(".",entry->d_name) == 0 || strcmp("..",entry->d_name) == 0) continue;
			printf("D %*s%s/\n",depth,"",entry->d_name);
			printdir(entry->d_name,depth+4);
		}
	}
	// chdir("..");
	closedir(dp);
}
int main(void)
{
	printf("dicr scan of /home/maney/sources:\n");
	// printdir("..",0);
	// OpenDir("/home/maney/sources", 0);
	OpenDir("..", 0);
	printf("done.\n");
	
	exit(0);
}

/* {{{ */
int OpenDir(char *path, int *item_count) {
	int		e;
	char	full_path[1024];
	DIR		*dirp;
	struct	dirent	*dp;
	struct	stat	fi;

	stat(path, &fi);
	if( fi.st_mode & S_IFDIR ) {
		sprintf(full_path, "%s/.", path);
		dirp = opendir(full_path);
		if( !dirp ) return eDIROpen;
		while( dirp != NULL) {
			if( (dp = readdir(dirp)) != NULL ) {
				sprintf(full_path, "%s/%s", path, dp->d_name);
				stat(full_path, &fi);
				if( (fi.st_mode & S_IFDIR) ) {
					if(	strcmp(dp->d_name, ".") && 
						strcmp(dp->d_name, "..") ) OpenDir(full_path, item_count);
				} else {
					fprintf(stdout, "%s\n", full_path);
					/*
					// e = LoadLog(full_path, item_count);
					if( e < eNoErr ) 
						fprintf(stderr, "Error at File %s Handling %d\n", full_path, e);
					*/
				}
			} else break;
		}
		closedir(dirp);
	} else  {
		fprintf(stdout, "%s\n", path);
		/*
		e = LoadLog(path, item_count, sort_mode);
		if( e < eNoErr ) 
			fprintf(stderr, "Error at File %s Handling %d\n", path, e);
		*/
	}
	return 0;
}
/* }}} */
